#include "CommonThread.h"

CommonThread::CommonThread(SimpleQueuePtr queue) {
	this->queue = queue;
}

void CommonThread::operator()() {
	ElementPtr elem;

	// sleep for a few nsecs to allow the main() loop to add some
	// elements into the vector before we start popping them off.	
	boost::xtime xt;
	boost::xtime_get(&xt, boost::TIME_UTC);
	xt.nsec += 300;
	boost::thread::sleep(xt);

	// now start popping the elements from the 'queue'
	cout << "Thread" << this << " is running." << endl;
	while(elem = queue->pop()) {
		for(int i=0; i< 5000; i++) { /*no op*/} 
		boost::mutex::scoped_lock scoped_lock(queue->mutex);
		if (elem) {
			cout << this <<": got " << elem->getMessage()->getString() << endl;
		}
	}
	cout << "Thread" << this << " is terminating..." << endl;
}

int main( void ) {
	SimpleQueuePtr queue = SimpleQueuePtr(new SimpleQueue1());
	boost::thread_group threads;
	
	for(int i = 0; i < 10; i++) {
		threads.create_thread(CommonThread(queue));
		
		// the message # is not real useful here
		ostringstream oss;
		oss << "Message # " << i;
		MessagePtr msg(new Message(oss.str(), queue));
		
		for (int j=0; j<1000; j++) {
			msg->putOnQueue();
		}
	}

	threads.join_all();
	return 0;
}


