#include "Element.h"
#include "SimpleQueue.h"

Message::Message(string str, SimpleQueuePtr queue) {
	this->str = str;
	this->queue = queue;
}

void Message::setString(string someval) {
	str = someval;	
}

string Message::getString() {
	return str;
}

void Message::putOnQueue() {
	MessagePtr tmpMsg = shared_from_this();
	ElementPtr tmpElem(new Element(tmpMsg));
	queue->add(tmpElem);
}

//*********************************************************

Element::Element(MessagePtr msg) {
	setMessage(msg);
}

Element::~Element() {
}

MessagePtr Element::getMessage() {
	return msg;
}

void Element::setMessage(MessagePtr msg) {
	this->msg = msg;
}
