#ifndef ELEMENT_H
#define ELEMENT_H

#include <iostream>
#include <boost/shared_ptr.hpp>
#include <boost/enable_shared_from_this.hpp>

using namespace std;
using namespace boost;

class SimpleQueue1;
typedef shared_ptr<SimpleQueue1> SimpleQueuePtr;

class Message : public enable_shared_from_this<Message>  {
private:
	string str;
	SimpleQueuePtr queue;
public:
	Message(string str, SimpleQueuePtr queue);
	string getString();
	void setString(string str);
	void putOnQueue(void);
};

typedef shared_ptr<Message> MessagePtr;

class Element {
	
public:
	Element(MessagePtr msg);
	virtual ~Element();
	void setMessage(MessagePtr msg);
	MessagePtr getMessage(void);
	
private:
	MessagePtr msg;
};

#endif // ELEMENT_H
